console.log('Iniciando PJe-Admissibilidade e PJe-Gestão.');

const listaTRTsAdmissibilidade = ['trt13', 'trt7', 'trt20'];
const listaTRTsGestao = ['trt13', 'trt6', 'trt19'];

const menuLateralSelector = "body > pje-root > mat-sidenav-container > mat-sidenav-content > div > pje-menu-lateral > nav";
waitForKeyElements(menuLateralSelector, function (elements) {
    const url = window.location.href;

    // PJe-Admissibilidade
    if (listaTRTsAdmissibilidade.some(trt => window.location.href.includes(trt))) {
        const controlador = new AdmissibilidadeControlador();
        controlador.acrescentarBotaoAdmissibilidade(menuLateralSelector);
        configurarObservadorPaginaTriagemOuAnalise();
    }

    // PJe-Gestão
    if (listaTRTsGestao.some(trt => window.location.href.includes(trt))) {
        main();
    }
});

const menuLateralSelectorAdmissibilidade = "body > pje-app-root > div > pje-app-execucao > div > div > execucao";
if (window.location.href.includes('pjeadmissibilidade')) {
    console.log('Iniciando PJe-Admissibilidade.');
    waitForKeyElements(menuLateralSelectorAdmissibilidade, function () {
        const url = window.location.href;
        console.log('Iniciou pjeadmissibilidade.');
        // PJe-Admissibilidade
        if (listaTRTsAdmissibilidade.some(trt => window.location.href.includes(trt))) {
            const controlador = new AdmissibilidadeControlador();
            controlador.acrescentarBotaoAdmissibilidade(menuLateralSelectorAdmissibilidade);
        }
    });
}


// exemplo: 0000540-70.2023.5.13.0029
async function inserirIconeAdmissibilidade(obj, observer) {
    let isNovaVersaoSAO = true;
    const dominioPje = window.location.hostname;
    let PREFIXO_SAO13 = 'SAO13-'
    const CODIGO_CONSULTA_SAO_ANTIGO = 'AD02';
    const urlConsultaProcurada = encodeURI(`https://${dominioPje}/pje-sao-api/api/usuario-consultas/${PREFIXO_SAO13}${CODIGO_CONSULTA_SAO_ANTIGO}`);
    await fetch(urlConsultaProcurada)
        .then(response => {
            if (!response.ok) {
                isNovaVersaoSAO = false;
            }
        })
        .catch(error => {
            isNovaVersaoSAO = false;
        });

    if (!isNovaVersaoSAO) {
        PREFIXO_SAO13 = '';
    }

    // Verifica se a URL atual é 'https://pje.../lista-processos'
    const textoTriagem = 'Triagem';
    const textoAnaliseGabinete = 'Análise de Gabinete';

    if (!obj.inseriu && window.location.href.includes('lista-processos')) {
        const elementosSpan = Array.from(document.querySelectorAll('span'));
        const elementoTriagemOuAnalise = elementosSpan.find(elemento =>
            (elemento.textContent.includes(textoTriagem) || elemento.textContent.includes(textoAnaliseGabinete)));
        const elementosImgClipboard = document.querySelectorAll('pje-icone-clipboard');
        let indxElementoImgClipboard = 0;

        if (elementoTriagemOuAnalise) {
            const elementosProcesso = elementosSpan.filter(elemento => elemento.className === 'mat-tooltip-trigger' && elemento.textContent.includes('.5.13.'));

            elementosProcesso.forEach(elementoProcesso => {
                const imgElementIcone = document.createElement('img');
                imgElementIcone.src = 'https://thenounproject.com/api/private/icons/3643768/edit/?backgroundShape=SQUARE&backgroundShapeColor=%23000000&backgroundShapeOpacity=0&exportSize=752&flipX=false&flipY=false&foregroundColor=%23000000&foregroundOpacity=1&imageFormat=png&rotation=0'
                imgElementIcone.style.width = '30px';
                imgElementIcone.style.height = '30px';
                const imgElementLinkAdmissibilidade = document.createElement('a');

                imgElementLinkAdmissibilidade.href = encodeURI(`https://${dominioPje}/pjeadmissibilidade/execucao/${PREFIXO_SAO13}${CODIGO_CONSULTA_SAO_ANTIGO}?${PREFIXO_SAO13}NUM_PROC_NULL=${elementoProcesso.textContent}`);
                imgElementLinkAdmissibilidade.target = '_blank';
                imgElementLinkAdmissibilidade.appendChild(imgElementIcone);
                const elementoImgClipboard = elementosImgClipboard.item(indxElementoImgClipboard++);
                elementoImgClipboard.parentElement.appendChild(imgElementLinkAdmissibilidade);
            });
            obj.inseriu = true;
        }
    } else {
        if (!window.location.href.includes('lista-processos')) {
            obj.inseriu = false;
        }
    }
}

// Necessario para passar parâmetro por referência
let objInseriuIconeEmTriagem = {inseriu: false};

function configurarObservadorPaginaTriagemOuAnalise() {
    const observer = new MutationObserver(async (mutationsList, observer) => {
        await inserirIconeAdmissibilidade(objInseriuIconeEmTriagem, observer);
    });

    // Configura o observador para observar todo o documento e suas mudanças
    observer.observe(document, {childList: true, subtree: true});
}
